import "dart:convert";
import "dart:io";

import 'package:recase/recase.dart';

void main(List<String> args) {
  File fontsConfigFile = File(args[0]);

  if (!fontsConfigFile.existsSync()) {
    print('config file not found');
    exit(0);
  }

  String content = fontsConfigFile.readAsStringSync();
  Map<String, dynamic> icons = json.decode(content);

  List<String> generatedOutput = [
    "library flutter_feather_icons;\n",
    "import \"package:flutter/widgets.dart\";\n",
    "import \"package:flutter_remix_icons/src/icon_data.dart\";\n\n",
    "// THIS FILE IS AUTOMATICALLY GENERATED!\n\n",
    "class RemixIcons {\n"
  ];

  icons.forEach((iconName, iconData) {
    String iconUnicode =
        (iconData as Map<String, dynamic>)["unicode"] as String;
    iconUnicode = iconUnicode.replaceAll('&#x', '');
    iconUnicode = iconUnicode.replaceAll(';', '');
    if (iconName.startsWith('4')) {
      print(iconUnicode);
      iconName = iconName.replaceAll('4', 'four');
    }
    if (iconName.startsWith('24')) {
      print(iconName);
      iconName = iconName.replaceAll('24', 'twentyFour');
    }

    generatedOutput.add(
        "static const IconData ${ReCase(iconName).camelCase} = const RemixIconData(0x$iconUnicode);\n");
  });

  generatedOutput.add("}\n");

  File output = File('../lib/flutter_remix_icons.dart');
  if (!output.existsSync()) output.createSync();
  output.writeAsStringSync(generatedOutput.join());
}
